<template src="./createImagesComponent.htm"></template>

<script>

    import Vue from 'vue';
    import FileComponent from '../../../../../inputs/FileComponent.vue';
    import ValidationErrorsMixin from '../../../../../mixins/validationErrorsMixin.js';

    Vue.component('file-component', FileComponent);

    export default {

        data() {

            return {

                images: []
            }
        },

        mixins: [ ValidationErrorsMixin ],

        methods: {

            /**
             * Push last processed image to images.
             *
             * @param image
             */
            pushToImages(image) {

                this.$refs.images.setErrors([]);

                this.images.push({

                    file: image.file,

                    preview: image.preview,

                    main: this.images.length < 1 ? 1 : 0
                });
            },


            /**
             * Change main attribute for selected image object.
             **/
            changeMain(index) {

                this.images.forEach( (el) => el.main = 0);

                this.images[index].main = 1;
            },


            /**
             * Remove image from array and make new main if selected was.
             **/
            removeImage(index) {

                let main = this.images[index].main;

                this.images.splice(index, 1);

                if (this.images.length > 0 && main === 1) {

                    this.changeMain(0);
                }
            }
        },

        watch: {

            /**
             * Push new images to store.
             */
            images: {

                handler(newImages) {

                    this.$store.dispatch('setProductImages', newImages);
                },

                deep: true
            }
        }
    }

</script>